# -*- coding:Utf-8 -*-

import es
import gamethread
import langlib
import random
import repeat

import psyco
psyco.full()

info = es.AddonInfo()
info['name']			= 'Versus Mod'
info['basename']		= 'l4d2vm'
info['version']		= '1.0.0 BETA'
info['author']			= 'GhoSt RideR: OriGinS'
info['url']			= 'http://addons.eventscripts.com/addons/view/l4d2vm'

es.ServerVar(info['name'], info['url']).makepublic()

HumanList = []
ZombieList = []
ZombieTypes = ['boomer', 'spitter', 'hunter', 'smoker', 'jockey', 'charger']

Players = {}

SpawnDelay = int(es.ServerVar('z_director_special_spawn_delay')) + 3

LangMsg = langlib.Strings(es.getAddonPath(info['basename']) + '/messages.ini')
			 
def load():
	es.regsaycmd('!team', 'l4d2vm/delayedPlayerTeam', ' ')
	es.regclientcmd('!team', 'l4d2vm/delayedPlayerTeam', ' ')
	es.regsaycmd('!spawn', 'l4d2vm/delayedPlayerSpawn', ' ')
	es.regclientcmd('!spawn', 'l4d2vm/delayedPlayerSpawn', ' ')
	
	repeat.create('l4d2vm_info', showInfo)
	repeat.start('l4d2vm_info', 80, 0)
	
def unload():
	es.unregsaycmd('!team')
	es.unregclientcmd('!team')
	es.unregsaycmd('!spawn')
	es.unregclientcmd('!spawn')
	
	repeat.stop('l4d2vm_info')
	repeat.delete('l4d2vm_info')
	
def es_map_start(event_var):
	global SpawnDelay
	SpawnDelay = int(es.ServerVar('z_director_special_spawn_delay')) + 3
	
	es.set('z_difficulty', 'hard')
	
def round_end(event_var):
	global Players
	global SpawnDelay
	SpawnDelay = int(es.ServerVar('z_director_special_spawn_delay')) + 3
		
	for userid in ZombieList:
		if Players[userid]['wait4spawn']:
			gamethread.cancelDelayed('versus_spawn_%s' %(userid))
			
	for userid in Players:
		Players[userid] = {
			'wait4team': False,
			'wait4spawn': False,
		}
	
def player_left_start_area(event_var):
	for userid in ZombieList:
		gamethread.delayed(4, spawnZombie, (userid), None)
		
def player_connect(event_var):
	global Players
	global ZombieList
	global HumanList
	
	if not event_var['userid']:
		return
		
	if event_var['networkid'] == 'BOT':
		return
		
	userid = event_var['userid']
	
	Players[userid] = {
		'wait4team': False,
		'wait4spawn': False,
	}
	
	if len(HumanList) >= 4:
		if len(ZombieList) >= 4:
			es.server.queuecmd('kickid %s Server Full' %(userid))
		
		else:
			HumanList.append(userid)
			changePlayerTeam(userid)
			
	else:
		HumanList.append(userid)
			
def player_activate(event_var):
	global Players
	
	if not event_var['userid']:
		return
		
	if event_var['es_steamid'] == 'BOT':
		return
		
	userid = event_var['userid']
	
	Players[userid]['language'] = es.createplayerlist()[int(userid)]['language'][:2]
	
def player_disconnect(event_var):
	global Players
	global ZombieList
	global HumanList
	
	if not event_var['userid']:
		return
		
	if event_var['networkid'] == 'BOT':
		return
	
	userid = event_var['userid']
	
	if userid in Players:
		del(Players[userid])
	
	if userid in HumanList:
		HumanList.remove(userid)
		
	if userid in ZombieList:
		ZombieList.remove(userid)

def player_death(event_var):
	if not event_var['userid']:
		return
		
	if event_var['es_steamid'] == 'BOT':
		return
		
	userid = event_var['userid']
		
	if userid in ZombieList:
		preloadSpawnZombie(userid)
		es.setplayerprop(userid, 'CBasePlayer.m_iObserverMode', 0)
	   
def finale_start(event_var):
	for userid in ZombieList:
		if es.getplayerprop(userid, 'CBasePlayer.pl.deadflag') == 1:
			spawnZombie(userid)
			
def delayedPlayerSpawn():
	preloadSpawnZombie(str(es.getcmduserid()))
	
def delayedPlayerTeam():
	global Players
	
	userid = str(es.getcmduserid())
	
	if not Players[userid]['wait4team']:
		Players[userid]['wait4team'] = True
		gamethread.delayedname(5, 'versus_team_%s' %(userid), changePlayerTeam, (userid), None)
		
		es.tell(userid, '#multi', LangMsg('delay_team', None, Players[userid]['language']))
	
def preloadSpawnZombie(userid):
	global Players
	
	userid = str(userid)
	
	if es.getplayerteam(userid) == 3:
		if es.getplayerprop(userid, 'CBasePlayer.pl.deadflag') == 1:
			if not Players[userid]['wait4spawn']:
				Players[userid]['wait4spawn'] = True
				gamethread.delayedname(SpawnDelay, 'versus_spawn_%s' %(userid), spawnZombie, (userid), None)
				
				es.tell(userid, '#multi', LangMsg('delay_spawn', None, Players[userid]['language']) %(SpawnDelay))
			
	else:
		if Players[userid]['wait4spawn']:
			Players[userid]['wait4spawn'] = False
			gamethread.cancelDelayed('versus_spawn_%s' %(userid))
	
def spawnZombie(userid):
	global Players
	
	userid = str(userid)
	
	if Players[userid]['wait4spawn']:
		Players[userid]['wait4spawn'] = False
		gamethread.cancelDelayed('versus_spawn_%s' %(userid))
	
	if es.getplayerteam(userid) == 3:
		es.flags('remove', 'cheat', 'z_spawn')
		es.sexec(userid, 'z_spawn %s auto' %(random.choice(ZombieTypes)))
		
		gamethread.delayed(0.15, es.playsound, (userid, 'ui/pickup_guitarriff10.wav', 1.0), None)
		
		es.flags('add', 'cheat', 'z_spawn')
		
def changePlayerTeam(userid):
	global Players
	global ZombieList
	global HumanList
	
	userid = str(userid)
	team = es.getplayerteam(userid)
	
	if team == 2:
		if len(ZombieList) >= 4:
			es.tell(userid, '#multi', LangMsg('full_team_zombie', None, Players[userid]['language']))
			
		else:
			es.tell(userid, '#multi', LangMsg('change_team_zombie', None, Players[userid]['language']))
			
			if len(HumanList) == 1:
				es.flags('remove', 'cheat', 'sb_all_bot_team')
				es.set('sb_all_bot_team', 1)
				
			es.changeteam(userid, 3)
				
			if userid in HumanList:
				HumanList.remove(userid)
			
			if not userid in ZombieList:
				ZombieList.append(userid)
				
			Players[userid]['wait4spawn'] = True
			gamethread.delayedname(SpawnDelay, 'versus_spawn_%s' %(userid), spawnZombie, (userid), None)
			
	elif team == 3:
		if len(HumanList) >= 4:
			es.tell(userid, '#multi', LangMsg('full_team_survivor', None, Players[userid]['language']))
			
		else:
			es.tell(userid, '#multi', LangMsg('change_team_survivor', None, Players[userid]['language']))
			
			es.flags('remove', 'cheat', 'sb_takecontrol')
			es.sexec(userid, 'sb_takecontrol')
			es.flags('add', 'cheat', 'sb_takecontrol')
			
			if es.ServerVar('sb_all_bot_team') == 1:
				es.set('sb_all_bot_team', 0)
				es.flags('add', 'cheat', 'sb_all_bot_team')
				
			if userid in ZombieList:
				ZombieList.remove(userid)
			
			if not userid in HumanList:
				HumanList.append(userid)
				
			if Players[userid]['wait4spawn']:
				Players[userid]['wait4spawn'] = False
				gamethread.cancelDelayed('versus_spawn_%s' %(userid))
				
	if Players[userid]['wait4team']:
		Players[userid]['wait4team'] = False
		gamethread.cancelDelayed('versus_team_%s' %(userid))
		
def showInfo(what):
	for userid in Players:
		langage = Players[userid]['language']
		
		es.tell(userid, '#multi', LangMsg('mod_info', None, langage))
		es.tell(userid, '#multi', LangMsg('key_info', None, langage))